# Wersja konstruująca nowe listy:
def quick_sort_easy(lst):
    if len(lst) < 2:
        return lst

    pivot = lst[-1]
    left = [x for x in lst if x < pivot]
    middle = [x for x in lst if x == pivot]
    right = [x for x in lst if x > pivot]

    return quick_sort_easy(left) + middle + quick_sort_easy(right)


# Wersja "w miejscu":
def partition(lst, lo, hi):
    # pivot musi być ostatnim elementem fragmentu
    pivot = lst[hi]
    i = lo
    for j in range(lo, hi):
        if lst[j] < pivot:
            lst[i], lst[j] = lst[j], lst[i]
            i += 1

    lst[i], lst[hi] = lst[hi], lst[i]
    return i


def quick_sort(lst):
    def quick_sort_segment(lo, hi):
        if lo >= hi:
            return
        i = partition(lst, lo, hi)
        quick_sort_segment(lo, i - 1)
        quick_sort_segment(i + 1, hi)

    quick_sort_segment(0, len(lst) - 1)


if __name__ == "__main__":
    test_lst = [5, 3, 4, 1, 2, 3]
    quick_sort(test_lst)
    print(test_lst)
